-- 神秘限购
Lua_MysteriousBuyWindow = class("Lua_MysteriousBuyWindow", Lua_Window);
function Lua_MysteriousBuyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MysteriousBuyWindow";
	self.skinName = "MysteriousBuyWindow_skin";
	self.showClose = false;
end

function Lua_MysteriousBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	local avo = DataCenter.OperationalActivitiesData:getActivitiesByType(Lua_OperationalActivitiesData.MYSTERIOUS_FIRST, 0);
	if avo == nil then
		self:hide();
		return;
	end
	self.updataInfo = true;

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 945, 328));
	self.dragList:setLocation(0, -110, 0);
	self.dragList:setListCell(Lua_MysteriousBuyItem, 328, 259, 1000);

	self.closeBtn:addClickFuntion(self, self.clickCloseBtn);

	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.updateMysteriousBuyInfo);
	self:addLuaEvent("UPDATE_WIN_DATA", self, self.setUpdataWinInfo);
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(avo.act_index, Lua_OperationalActivitiesData.MYSTERIOUS_FIRST);
end

function Lua_MysteriousBuyWindow:updateMysteriousBuyInfo()
	if DataCenter.OperationalActivitiesData.act_detail == nil or self.updataInfo == false then
		return;
	end

	local info = DataCenter.OperationalActivitiesData.act_detail;
	local rewardInfo = info.reward_info;
	local dataList = Array();
	for i = 1, #rewardInfo do
		dataList:add({act_index = info.act_index, rewardInfo = rewardInfo[i], flag = 0});
	end
	self.dragList:setLuaArrayData(dataList, false);
	self.updataInfo = false;
end

function Lua_MysteriousBuyWindow:setUpdataWinInfo(dataDic)
	for i = 1, self.dragList.showList:getSize() do
		if tonumber(self.dragList.showList[i]._data.rewardInfo.index) == tonumber(dataDic.index) then
			self.dragList.showList[i]._data.flag = dataDic.flag;
		end
	end
end

function Lua_MysteriousBuyWindow:clickCloseBtn()
	if DataCenter.neverTip:getNeverValue(Lua_NeverTipData.MYSTERIOUS) then
		Lua_WindowUtil.openWin("Lua_MysteriousBuyWindow", WinParam.ACTION_CLOSE);
	else
		Lua_WindowUtil.openWin("Lua_MysteriousBuyTipsWindow", WinParam.ACTION_OPEN);
	end
end

function Lua_MysteriousBuyWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MysteriousBuyItem = class("Lua_MysteriousBuyItem", Lua_ListCell);
function Lua_MysteriousBuyItem:ctor(p)
	self:superCall("ctor", p, "MysteriousBuyItem_skin");
end

function Lua_MysteriousBuyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(-2, 104.5, 0);

	self.buybtn.label = LanUtil.getValue(127407);
	self.buybtn:setBtnEnable(true);
	self.buybtn:addClickFuntion(self, self.buyBtnClick);
end

function Lua_MysteriousBuyItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.zhekouLab.text = Lua_CommonUtil.transChineseNumber(data.rewardInfo.cond[6]).."折";

	local reward = Lua_ToolVo.createToolVo(data.rewardInfo.reward_set[1].id, data.rewardInfo.reward_set[1].amount, data.rewardInfo.reward_set[1].bind);
	for i = 1, #data.rewardInfo.spec_effect_item do
		if tonumber(data.rewardInfo.reward_set[1].id) == tonumber(data.rewardInfo.spec_effect_item[i]) then
			-- self.itemImg:showRoundEff(true);
			reward.roundEffect = true;
		end
	end

	if data.rewardInfo.reward_set[1].equipment ~= nil then
		-- self.itemImg:showStars(tonumber(data.rewardInfo.reward_set[1].equipment.star))
		reward.star = tonumber(data.rewardInfo.reward_set[1].equipment.star);
	end
	self.itemImg.data = reward;

	self.titleLab.text = reward.colorName;

	self.ypice = tonumber(data.rewardInfo.cond[4]);
	self.yuanjia.text = LanUtil.getValue(127400)..self.ypice;
	self.money:setAltas("icon_atlas_3", "money_"..data.rewardInfo.cond[5]);
	self.money:setLocation(self.yuanjia.mainContent.transform.localPosition.x + self.yuanjia.width + 7, -7, 0);

	self.xpice = tonumber(data.rewardInfo.cond[3]);
	self.xianjia.text = LanUtil.getValue(127401)..self.xpice;
	self.money2:setAltas("icon_atlas_3", "money_"..data.rewardInfo.cond[5]);
	self.money2:setLocation(self.xianjia.mainContent.transform.localPosition.x + self.xianjia.width + 7, -35, 0);

	if data.flag == 0 then
		self.buybtn:setBtnEnable(true);
		self.buybtn.label = LanUtil.getValue(127407);
	elseif data.flag == 1 then
		self.buybtn:setBtnEnable(false);
		self.buybtn.label = LanUtil.getValue(127406);
	elseif data.flag == 2 then
		self.buybtn:setBtnEnable(false);
		self.buybtn.label = LanUtil.getValue(127407);
	end

	self.tempTime = data.rewardInfo.arrive_tick;
	self:startTimer();
	self:setTime();
end

function Lua_MysteriousBuyItem:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_MysteriousBuyItem", 1, self, self.setTime);
	end
end

function Lua_MysteriousBuyItem:setTime()
	self.tempTime = self.tempTime - 1;
	local str = TimeTransform.getInstance():transSeconds6(math.floor(self.tempTime), true, true);
	self.tipsLab.text = LanUtil.getValue(127402)..str;
	if self.tempTime <= 0 then
		self:endTimer();
		self.buybtn:setBtnEnable(false);
		Lua_MsgUtil.callFunc("UPDATE_WIN_DATA", {index = tonumber(self._data.rewardInfo.index), flag = 2});
	end
end

function Lua_MysteriousBuyItem:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.setTime);
	end
end

function Lua_MysteriousBuyItem:buyBtnClick(go)
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local leftNum = bagData:getLeftSize()
	if leftNum <= 0 then
		DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK)
		return;
	end
	
	if tonumber(self._data.rewardInfo.cond[5]) == Lua_MoneyData.GOLD and DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.xpice then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(110818), type = 1, subFun = self.onSubCallback});
	elseif tonumber(self._data.rewardInfo.cond[5]) == Lua_MoneyData.BIND_GOLD then
		if DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < self.xpice and DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.xpice then
			OperateAlert.show(LanUtil.getValue(127403));
		elseif DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < self.xpice and DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) >= self.xpice then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(127405), type = 1, subFun = self.onBuyCallback});
		else
			self:onBuyCallback();
		end
	elseif tonumber(self._data.rewardInfo.cond[5]) == Lua_MoneyData.COPPER and DataCenter.moneyData:getMoney(tonumber(self._data.rewardInfo.cond[5])) < self.xpice then
		OperateAlert.show(LanUtil.getValue(127404));
	else
		self:onBuyCallback();
	end
end

function Lua_MysteriousBuyItem:onSubCallback()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
end

function Lua_MysteriousBuyItem:onBuyCallback()
	self.buybtn:setBtnEnable(false);
	self.buybtn.label = LanUtil.getValue(127406);
	DataCenter.OperationalActivitiesData:buyReward(tonumber(self._data.act_index), tonumber(self._data.rewardInfo.index), 1);
	Lua_MsgUtil.callFunc("UPDATE_WIN_DATA", {index = tonumber(self._data.rewardInfo.index), flag = 1});
end

function Lua_MysteriousBuyItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 30, self.itemY, 60, 20);
	self.itemImg:showRoundEff(showRect:containeRect(rect));
end

function Lua_MysteriousBuyItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;
	self:endTimer();
	
	self:superCall("dispose");
end